GameOverWindow = class(Turbine.UI.Lotro.Window)
function GameOverWindow:Constructor(characterData)
    Turbine.UI.Lotro.Window.Constructor(self)

    self.characterData = characterData
    self.width = 500
    self.height = 500
    self:SetSize(self.width, self.height)
    self:SetText("Game Over!")
    self:SetPosition(Turbine.UI.Display.GetWidth() / 2 - self.width / 2, Turbine.UI.Display.GetHeight() / 2 - self.height / 2)
    self:SetVisible(not(self.inProgress))

    self.iconControl = Turbine.UI.Control()
    self.iconControl:SetParent(self)

    self.iconControl:SetPosition(20, 50)
    self.iconControl:SetBackground("Hardcore/Images/Monitor.tga")
    self.iconControl:SetStretchMode(2)
    self.iconControl:SetSize(self:GetWidth(), self:GetHeight())
    self.iconControl:SetStretchMode(1)
    self.iconControl:SetSize(150, 150)
    self.iconControl:SetPosition(self.width / 2 - 80, 50)

    local labelOffset = 200

    self.reasonLabel = Turbine.UI.Label()
    self.reasonLabel:SetParent(self)
    self.reasonLabel:SetSize(self.width, 20)
    self.reasonLabel:SetPosition(20, labelOffset)
    self.reasonLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.reasonLabel:SetOutlineColor(Turbine.UI.Color.Black)
    self.reasonLabel:SetFont(Turbine.UI.Lotro.Font.Verdana23)
    self.reasonLabel:SetText("Reason")

    labelOffset = labelOffset + 30

    self.reasonTextLabel = Turbine.UI.Label()
    self.reasonTextLabel:SetParent(self)
    self.reasonTextLabel:SetSize(self.width, 20)
    self.reasonTextLabel:SetPosition(20, labelOffset)
    self.reasonTextLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.reasonTextLabel:SetOutlineColor(Turbine.UI.Color.Black)
    self.reasonTextLabel:SetFont(Turbine.UI.Lotro.Font.Verdana18)
    self.reasonTextLabel:SetText(self.characterData.Fail_Reason)


    self.statControl = StatControl(characterData, self)
    self.statControl:SetPosition(0, labelOffset)
end

StatControl = class(Turbine.UI.Control)
function StatControl:Constructor(characterData, parent, startTime)
    Turbine.UI.Control.Constructor(self)
    self.characterData = characterData
    self.width =  500
    self.height = 400

    self:SetSize(self.width, self.height)
    self:SetParent(parent)

    if not(self.characterData) then
        return
    end


    --self.iconControl:SetBackColor(Turbine.UI.Color.Red)

    local labelOffset = 00 


    labelOffset = labelOffset + 40

    self.statLabel = Turbine.UI.Label()
    self.statLabel:SetParent(self)
    self.statLabel:SetSize(self.width, 20)
    self.statLabel:SetPosition(20, labelOffset)
    self.statLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.statLabel:SetOutlineColor(Turbine.UI.Color.Black)
    self.statLabel:SetFont(Turbine.UI.Lotro.Font.Verdana23)
    self.statLabel:SetText("Stats")

    labelOffset = labelOffset + 30

    self.playtimeLabel = Turbine.UI.Label()
    self.playtimeLabel:SetParent(self)
    self.playtimeLabel:SetSize(self.width, 20)
    self.playtimeLabel:SetPosition(20, labelOffset)
    self.playtimeLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.playtimeLabel:SetOutlineColor(Turbine.UI.Color.Black)
    self.playtimeLabel:SetFont(Turbine.UI.Lotro.Font.Verdana18)
    local playTime
    if startTime then
        playTime = self.characterData.PlayTime + (Turbine.Engine.GetGameTime() - startTime)
    else
        playTime = self.characterData.PlayTime
    end
    self.playtimeLabel:SetText("Total play time: " .. PrimeUtils.Utils.FormatTimeStringWritten(playTime))

    labelOffset = labelOffset + 20

    self.achievementLabel = Turbine.UI.Label()
    self.achievementLabel:SetParent(self)
    self.achievementLabel:SetSize(self.width, 20)
    self.achievementLabel:SetPosition(20, labelOffset)
    self.achievementLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.achievementLabel:SetOutlineColor(Turbine.UI.Color.Black)
    self.achievementLabel:SetFont(Turbine.UI.Lotro.Font.Verdana18)
    self.achievementLabel:SetText("Total achievements completed: " .. PrimeUtils.Utils.Tablelength(self.characterData.Achievements_Done))

    labelOffset = labelOffset + 20

    self.questLabel = Turbine.UI.Label()
    self.questLabel:SetParent(self)
    self.questLabel:SetSize(self.width, 20)
    self.questLabel:SetPosition(20, labelOffset)
    self.questLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.questLabel:SetOutlineColor(Turbine.UI.Color.Black)
    self.questLabel:SetFont(Turbine.UI.Lotro.Font.Verdana18)
    self.questLabel:SetText("Total quests completed: " .. PrimeUtils.Utils.Tablelength(self.characterData.Completed_Quests))

    labelOffset = labelOffset + 20

    self.deedLabel = Turbine.UI.Label()
    self.deedLabel:SetParent(self)
    self.deedLabel:SetSize(self.width, 20)
    self.deedLabel:SetPosition(20, labelOffset)
    self.deedLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.deedLabel:SetOutlineColor(Turbine.UI.Color.Black)
    self.deedLabel:SetFont(Turbine.UI.Lotro.Font.Verdana18)
    self.deedLabel:SetText("Total deeds completed: " .. PrimeUtils.Utils.Tablelength(self.characterData.Completed_Deeds))

    labelOffset = labelOffset + 20

    
    self.dungeonsLabel = Turbine.UI.Label()
    self.dungeonsLabel:SetParent(self)
    self.dungeonsLabel:SetSize(self.width, 20)
    self.dungeonsLabel:SetPosition(20, labelOffset)
    self.dungeonsLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.dungeonsLabel:SetOutlineColor(Turbine.UI.Color.Black)
    self.dungeonsLabel:SetFont(Turbine.UI.Lotro.Font.Verdana18)
    self.dungeonsLabel:SetText("Total dungeons completed: " .. PrimeUtils.Utils.Tablelength(self.characterData.Dungeons))

    labelOffset = labelOffset + 20

    local Monster_Kills = 0
    for key, value in pairs(self.characterData.Monster_Kills) do
        Monster_Kills = Monster_Kills + value
    end

    self.killLabel = Turbine.UI.Label()
    self.killLabel:SetParent(self)
    self.killLabel:SetSize(self.width, 20)
    self.killLabel:SetPosition(20, labelOffset)
    self.killLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.killLabel:SetOutlineColor(Turbine.UI.Color.Black)
    self.killLabel:SetFont(Turbine.UI.Lotro.Font.Verdana18)
    self.killLabel:SetText("Total monsters killed: " .. Monster_Kills)





    labelOffset = labelOffset + 30


end

QuestLogControl = class(Turbine.UI.Control)
function QuestLogControl:Constructor(characterData, parent)
    Turbine.UI.Control.Constructor(self)
    self.characterData = characterData
    self.width = 800
    self.height = 700

    self:SetSize(self.width, self.height)
    self:SetParent(parent)

    if not(self.characterData) then
        return
    end

    local labelOffset = 0

    self.levelLogLabel = Turbine.UI.Label()
    self.levelLogLabel:SetParent(self)
    self.levelLogLabel:SetSize(self.width, 30)
    self.levelLogLabel:SetPosition(20, labelOffset)
    self.levelLogLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.levelLogLabel:SetOutlineColor(Turbine.UI.Color.Black)
    self.levelLogLabel:SetFont(Turbine.UI.Lotro.Font.Verdana23)
    self.levelLogLabel:SetText("Level Log")

    labelOffset = labelOffset + 30

    self.levelLogListBox = Turbine.UI.ListBox()
    self.levelLogListBox:SetParent(self)
    self.levelLogListBox:SetSize(self.width - 40, 200)
    self.levelLogListBox:SetPosition(20, labelOffset)

    self.levelLogScrollbar = Turbine.UI.Lotro.ScrollBar()
    self.levelLogScrollbar:SetParent(self)
    self.levelLogScrollbar:SetSize(10, 250)
    self.levelLogScrollbar:SetPosition(self.width - 20, labelOffset)
    self.levelLogScrollbar:SetOrientation(Turbine.UI.Orientation.Vertical)
    self.levelLogListBox:SetVerticalScrollBar(self.levelLogScrollbar)

    local colourIndex = 0
    for key, value in pairs(self.characterData.Level_Log) do
        local levelLogControl = Turbine.UI.Control()
        levelLogControl:SetSize(self.width - 40, 30)
        levelLogControl:SetBackColor(Turbine.UI.Color.Black)

        local levelLogLabel = Turbine.UI.Label()
        levelLogLabel:SetParent(levelLogControl)
        levelLogLabel:SetSize(self.width - 40 - 2, 30 - 2)
        levelLogLabel:SetPosition(1, 1)
        levelLogLabel:SetFontStyle(Turbine.UI.FontStyle.Outline)
        levelLogLabel:SetOutlineColor(Turbine.UI.Color.Black)
        levelLogLabel:SetFont(Turbine.UI.Lotro.Font.Verdana14)
        levelLogLabel:SetText(value)

        if colourIndex % 2 == 0 then
            levelLogLabel:SetBackColor(Turbine.UI.Color.Gray)
        else
            levelLogLabel:SetBackColor(Turbine.UI.Color.LightGray)
        end

        colourIndex = colourIndex + 1

        self.levelLogListBox:AddItem(levelLogControl)
    end
end